#include "stdafx.h"
#include "matlab5.h"
#include "matlab5Dlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma warning(disable : 4244 34)	// double->int Umwandlung Warnung beim Draw-en

CMatlab5Dlg::CMatlab5Dlg(CWnd* pParent)
: CDialog(CMatlab5Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMatlab5Dlg)
	m_string_dgl = _T("");
	m_string_exakt = _T("");
	m_status = _T("");
	m_N = _T("");
	m_TOL = _T("");
	m_X0 = _T("");
	m_X1 = _T("");
	m_Y0 = _T("");
	m_Y1 = _T("");
	m_PFAD = _T("");
	m_ITMAX = _T("");
	m_kommastellen = _T("");
	m_toleranz = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	xpaint = NULL;
	ypaint = NULL;
}

void CMatlab5Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMatlab5Dlg)
	DDX_Control(pDX, IDC_LISTE, m_combobox);
	DDX_Control(pDX, IDC_WRITEOK, m_writeok);
	DDX_Text(pDX, IDC_DGL, m_string_dgl);
	DDX_Text(pDX, IDC_EXAKT, m_string_exakt);
	DDX_Text(pDX, IDC_STATUSFENSTER, m_status);
	DDX_Text(pDX, IDC_N, m_N);
	DDX_Text(pDX, IDC_TOL, m_TOL);
	DDX_Text(pDX, IDC_X0, m_X0);
	DDX_Text(pDX, IDC_X1, m_X1);
	DDX_Text(pDX, IDC_Y0, m_Y0);
	DDX_Text(pDX, IDC_Y1, m_Y1);
	DDX_Text(pDX, IDC_PFAD, m_PFAD);
	DDX_Text(pDX, IDC_ITMAX, m_ITMAX);
	DDX_Text(pDX, IDC_KOMMA, m_kommastellen);
	DDX_Text(pDX, IDC_TOL2, m_toleranz);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMatlab5Dlg, CDialog)
//{{AFX_MSG_MAP(CMatlab5Dlg)
ON_BN_CLICKED(IDSTART, OnStart)
ON_BN_CLICKED(IDDRAW, OnDrawButton)
ON_WM_PAINT()
ON_LBN_SELCHANGE(IDC_LISTE, OnSelchangeListe)
ON_BN_CLICKED(IDC_WRITEOK, OnTxtButton)
ON_BN_CLICKED(IDDEX1, OnExtrapolation)
ON_BN_CLICKED(IDDEX2, OnGnuplot)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatlab5Dlg Nachrichten-Handler

BOOL CMatlab5Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	SetIcon(m_hIcon, TRUE);
	m_PFAD = _T("d:\\matlab5");
	m_kommastellen = "5";
	
	// Funktionsauswahl
	m_combobox.AddString("Funktion 1");
	m_combobox.AddString("Funktion 2");
	m_combobox.AddString("Funktion 3");
	m_combobox.AddString("Funktion 4");
	m_combobox.AddString("Funktion 5");
	m_combobox.SetCurSel(0);
	
	OnSelchangeListe();
	UpdateData(FALSE);
	
	return TRUE;
}

// Implementierung der Funktion und der Ableitugn nach Y und Y'
double CMatlab5Dlg::f(double x, double y, double ys, int auswahl)
{
	if (auswahl == 1) 
	{
		m_string_dgl = "(32 + 2x - y*y') / 8";
		m_string_exakt = "x + 16/x";
		return ((32.0 + 2.0*x*x*x - y*ys)/8.0);
	}
	else if (auswahl == 2)
	{
		m_string_dgl = "2y - 6y - 2x";
		m_string_exakt = "x + 1/x";
		return (2.0*y*y*y - 6.0*y - 2.0*x*x*x);
	}
	else if (auswahl == 3)
	{
		m_string_dgl = "y * (y - y')";
		m_string_exakt = "1 / (1 + x)";
		return (y*(y*y - ys));
	}
	else if (auswahl == 4)
	{
		m_string_dgl = "y' + 2*(y-log(x)) - 1/x";
		m_string_exakt = "1/x + log(x)";
		return (ys + - 1.0/x + 2.0*(y - log(x))*(y - log(x))*(y - log(x)));
	}
	else if (auswahl == 5)
	{
		m_string_dgl = "(x * y' - 9y + 4x^6) / x^5";
		m_string_exakt = "x * log(x)";
		return ((x*x * ys*ys - 9*y*y + 4*x*x*x*x*x*x) / (x*x*x*x*x));
	}
	else return 13371337.0;
}
double CMatlab5Dlg::fy(double x, double y, double ys, int auswahl)
{
	if (auswahl == 1) return (-ys / 8.0);
	else if (auswahl == 2) return (6.0*y*y - 6.0);
	else if (auswahl == 3) return (3.0*y*y - ys);
	else if (auswahl == 4) return (6.0 * (y-log(x))*(y-log(x)));
	else if (auswahl == 5) return (-18.0 * y / (x*x*x*x*x));
	else return 13371337.0;
}
double CMatlab5Dlg::fys(double x, double y, double ys, int auswahl)
{
	if (auswahl == 1) return (-y / 8.0);
	else if (auswahl == 2) return (0.0);
	else if (auswahl == 3) return (-y);
	else if (auswahl == 4) return (1.0);
	else if (auswahl == 5) return (2.0 * ys / (x*x*x));
	else return 13371337.0;
}

double CMatlab5Dlg::fexakt(double x, int auswahl)
{
	if (auswahl == 1) return (x*x + 16.0/x);
	else if (auswahl == 2) return (x + 1.0/x);
	else if (auswahl == 3) return (1.0 / (1.0 + x));
	else if (auswahl == 4) return (1.0/x + log(x));
	else if (auswahl == 5) return (x*x*x*log(x));
	else return 13371337.0;
}

// Eigentlicher Algorithmus
BOOL CMatlab5Dlg::DiffVerfahren(int auswahl, int N)
{
	UpdateData(TRUE);
	
	// Initialisierung
	double x0 = strtod(m_X0, '\0');
	double y0 = strtod(m_Y0, '\0');
	double xn = strtod(m_X1, '\0');
	double yn = strtod(m_Y1, '\0');
	double TOL = strtod(m_TOL, '\0');
	int ITMAX = atoi(m_ITMAX);
	
	//Dynamisches Initialisieren der Arrays
	double* a = (double*) malloc((N+2) * sizeof(double));
	double* b = (double*) malloc((N+2) * sizeof(double));
	double* c = (double*) malloc((N+2) * sizeof(double));
	double* d = (double*) malloc((N+2) * sizeof(double));
	double* ywert = (double*) malloc((N+2) * sizeof(double));
	double* u = (double*) malloc((N+2) * sizeof(double));
	double* z = (double*) malloc((N+2) * sizeof(double));
	double* v = (double*) malloc((N+2) * sizeof(double));
	double* l = (double*) malloc((N+2) * sizeof(double));
	
	double x, t, h;
	int iIteration = 1;
	char sIteration[16];
	CString Inhalt ="";
	
	h = (xn - x0) / (N + 1.0);
	ywert[0] = y0;
	ywert[N+1] = yn;
	
	// y Werte linear vor Iteration vorbelegen (Steigungsdreieck)
	for (int i=1; i<=N; i++)
	{		
		ywert[i] = y0 + i * h * (yn - y0) / (xn - x0); 
	}
	
	while (iIteration <= abs(ITMAX))
	{
		// Jede Iteration einmal hier durch
		_itoa(iIteration, sIteration, 10);
		Inhalt = Inhalt + "Iterationsschritt: " + sIteration + "\r\n";
		Inhalt = Inhalt + "Y: " +  ShowVec(ywert, N, atoi(m_kommastellen)) + "\r\n";
		m_status = Inhalt;
		UpdateData(FALSE);
		
		// Matrix aufbauen und lsen -> neue ywerte
		// Erste Spalte
		x = x0 + h;
		t = (ywert[2] - ywert[0]) / (2.0*h);
		a[1] = 2.0 + h*h * fy(x, ywert[1], t, auswahl);
		b[1] = -1.0 + 0.5 * h * fys(x, ywert[1], t, auswahl);
		d[1] = -(2.0*ywert[1] - ywert[2] - ywert[0] + h*h * f(x, ywert[1], t, auswahl));
		
		for (i=2; i<=N-1; i++)
		{
			x = x0 + i * h;
			t = (ywert[i+1] - ywert[i-1])/ (2.0*h);
			a[i] = 2.0 + h*h * fy(x, ywert[i], t, auswahl);
			b[i] = -1.0 + 0.5 * h * fys(x, ywert[i], t, auswahl);
			c[i] = -1.0 - 0.5 * h * fys(x, ywert[i], t, auswahl);
			d[i] = -(2.0*ywert[i] - ywert[i+1] - ywert[i-1] + h*h * f(x, ywert[i], t, auswahl));
		}
		
		// Letzte Spalte
		x = xn - h;
		t = (ywert[N+1] - ywert[N-1]) / (2.0*h);
		a[N] = 2.0 + h*h * fy(x, ywert[N], t, auswahl);
		c[N] = -1 - 0.5 * h * fys(x, ywert[N], t, auswahl);
		d[N] = -(2.0*ywert[N] - ywert[N-1] - ywert[N+1] + h*h * f(x, ywert[N], t, auswahl));
		
		// tridiagonales GS aufbauen und lsen -> liefert Korrekturvektor fr Y
		l[1] = a[1];
		u[1] = b[1] / a[1];
		z[1] = d[1] / l[1];
		
		for (int i=2; i<=N-1; i++)
		{
			l[i] = a[i] - c[i] * u[i-1];
			u[i] = b[i] / l[i];
			z[i] = (d[i] - c[i] * z[i-1]) / l[i];
		}
		
		l[N] = a[N] - c[N] * u[N-1];
		z[N] = (d[N] - c[N] * z[N-1]) / l[N];
		
		// Werte korrigieren
		v[0] = 0.0;
		v[N] = z[N];
		v[N+1] = 0.0;
		ywert[N] += v[N];
		for (int j=N-1; j>=1; j--)
		{
			v[j] = z[j] - u[j] * v[j+1];
			ywert[j] += v[j];
		}
		
		Inhalt = Inhalt + "V: " +  ShowVec(v, N, atoi(m_kommastellen)) + "\r\n";
		
		// Norm berechnen
		double norm = fabs(v[1]);
		for (int k=2; k<=N+1; k++)
		{
			if (fabs(v[k]) > norm) norm = fabs(v[k]);	
		}
		
		Inhalt = Inhalt + "Norm von V: " + d2a(norm, atoi(m_kommastellen)) +"     Lnge der Vektoren: " + i2a(N+2) +"\r\n\r\n";
		m_status = Inhalt;
		UpdateData(FALSE);
		
		// Toleranz checken
		if (norm <= TOL)
		{
			reinterpret_cast<CButton *>(GetDlgItem(IDDRAW))->EnableWindow(TRUE);	//Draw frei
			// Werte akzeptieren
			Inhalt = Inhalt + "Toleranz in Schritt " + i2a(iIteration) + " erreicht --> Abbruch\r\n";
			m_status = Inhalt;
			UpdateData(FALSE);
			
			// Ausgabe in Datei
			CFile datei;
			CString sZeile;
			double dMaxFehler = 0.0;
			int nachkommastellen = 12;
			if (datei.Open(m_PFAD +".txt", CFile::modeCreate|CFile::modeWrite))
			{
				double x_temp;
				double fehler;
				for (int i=0; i<=N+1; i++)
				{
					x_temp = x0 + i * h;
					fehler = fabs(ywert[i]-fexakt(x_temp, auswahl));
					if (fehler > dMaxFehler) dMaxFehler = fehler;
					
					// Ausgabe: x, y_berechnet, y_exakt, |y_berechnet-y_fehler|, jeweils 12 nachkommastellen
					sZeile = d2a(x_temp, nachkommastellen) + "	" + d2a(ywert[i], nachkommastellen) + "	" +d2a(fexakt(x_temp, auswahl), nachkommastellen) +  "	" +d2a(fehler, nachkommastellen) + "\n";
					datei.Write(sZeile, sZeile.GetLength());
					xpaint[i] = x_temp;
					ypaint[i] = ywert[i];
				}
				sZeile += "\n\nMaximaler Fehler: " + d2a(dMaxFehler, nachkommastellen) + " zu N=" + i2a(N);
				datei.Write(sZeile, sZeile.GetLength());
				datei.Close();
				Inhalt = Inhalt + "Daten in Datei " + m_PFAD + ".txt geschrieben.\r\n";
				m_writeok.ShowWindow(SW_SHOW);
				m_status = Inhalt;
				UpdateData(FALSE);
				free(a);
				free(b);
				free(c);
				free(d);
				free(ywert);
				free(u);
				free(z);
				free(v);
				return TRUE;
			}
			
			else {AfxMessageBox("Konnte nicht in Datei " + m_PFAD + "schreiben"); return FALSE;}
		}
		else iIteration++;
	}// While ENDE
	free(a);
	free(b);
	free(c);
	free(d);
	free(ywert);
	free(u);
	free(z);
	free(v);
	return FALSE;
}

// Wenn aufn Startbutton geklickt
void CMatlab5Dlg::OnStart() 
{
	Invalidate();
	UpdateData(TRUE);

	// sehr exakte Zeitmessung
	LARGE_INTEGER ZeitFrequenz, ZeitStart, ZeitStop;
	QueryPerformanceFrequency(&ZeitFrequenz);
		
	m_status = "";
	m_toleranz = GetTol(strtod(m_TOL, '\0'));
	
	UpdateData(FALSE);
	m_writeok.ShowWindow(SW_HIDE);
	reinterpret_cast<CButton *>(GetDlgItem(IDDRAW))->EnableWindow(FALSE);

	xpaint = (double*) malloc((atoi(m_N)+2) * sizeof(double));
	ypaint = (double*) malloc((atoi(m_N)+2) * sizeof(double));
	QueryPerformanceCounter(&ZeitStart);
	DiffVerfahren(m_combobox.GetCurSel()+1, atoi(m_N));	// bergame = Funktionsnummer und N
	QueryPerformanceCounter(&ZeitStop);
	double tErgebnis = ((double)ZeitStop.QuadPart - (double)ZeitStart.QuadPart) / (double)ZeitFrequenz.QuadPart;
	m_status += "Bentigte Zeit: " + d2a(tErgebnis*1000, 12) + " ms";
	UpdateData(FALSE);
	reinterpret_cast<CEdit *>(GetDlgItem(IDC_STATUSFENSTER))->LineScroll(999);
}

// Double in String
CString CMatlab5Dlg::d2a(double wert, int kommastellen)
{
	char buffer[32];
	_itoa(kommastellen, buffer, 10);
	sprintf(buffer, "%."+(CString)buffer+"lf", wert);
	return (CString)buffer;
}

// Int in String
CString CMatlab5Dlg::i2a(int wert)
{
	char buffer[32];
	_itoa(wert, buffer, 10);
	return (CString)buffer;
}

// Liefert den Inhalt eines Double-Vektors als String zurck
CString CMatlab5Dlg::ShowVec(double* array, int laenge, int nachkommastellen)
{
	CString rueckgabe = "";
	for (int i=0; i<=laenge+1; i++)
	{
		rueckgabe = rueckgabe + d2a(array[i], nachkommastellen) + " ";
	}
	return rueckgabe;
}

void CMatlab5Dlg::OnDrawButton() 
{
	Invalidate();
	
	CWnd* rahmen = GetDlgItem(IDC_BOX);
	rahmen->ModifyStyleEx(NULL , WS_EX_LEFTSCROLLBAR); 
	
	UpdateData(TRUE);
	int m_n = atoi(m_N);
	CPaintDC dc(this);
	
	//linke Achse
	dc.MoveTo(60, 125);
	dc.LineTo(60, 337);
	
	//Pfeil linke Achse
	dc.MoveTo(60, 115);
	dc.LineTo(55,125);
	dc.LineTo(65,125);
	dc.LineTo(60,115);
	dc.TextOut(69, 112, 'y');
	
	//untere Achse
	dc.MoveTo(55, 332);
	dc.LineTo(350, 332);
	
	//Pfeil untere Achse
	dc.MoveTo(360, 332);
	dc.LineTo(350, 327);
	dc.LineTo(350, 336);
	dc.LineTo(360, 332);
	dc.TextOut(350, 310, 'x');
	
	//xmin, xmax, ymin, ymax finden
	double xmin, ymin, xmax, ymax;
	xmin=xpaint[0];
	xmax=xpaint[0];
	ymin=ypaint[0];
	ymax=ypaint[0];
	for(int i=1; i<=m_n+1; i++)
	{
		xmin = xmin < xpaint[i] ? xmin : xpaint[i];
		xmax = xmax > xpaint[i] ? xmax : xpaint[i];
		ymin = ymin < ypaint[i] ? ymin : ypaint[i];
		ymax = ymax > ypaint[i] ? ymax : ypaint[i];
	}
	
	// skalierungsfaktor finden fuer den diff. zwischen min und max werten = breite/hoehe der box
	int xskal = 260 / (xmax-xmin);
	int yskal = 170 / (ymax-ymin);
	
	int xabs=55;
	int yabs=337;
	
	int xoffset = xabs+30 - xpaint[0]*xskal;
	int yoffset = yabs-30 + ymin*yskal;
	
	// Marker X Achse
	dc.MoveTo((int) xoffset+(xpaint[0]*xskal), 334);
	dc.LineTo((int) xoffset+(xpaint[0]*xskal), 328);
	dc.TextOut(xoffset+(xpaint[0]*xskal)-15, 310, d2a(xpaint[0], 2));
	dc.MoveTo((int) xoffset+(xpaint[m_n+1]*xskal), 334);
	dc.LineTo((int) xoffset+(xpaint[m_n+1]*xskal), 328);
	dc.TextOut(xoffset+(xpaint[m_n+1]*xskal)-15, 310, d2a(xpaint[m_n+1], 2));
	
	// Marker Y Achse
	dc.MoveTo(58, (int) yoffset+ypaint[0]*(-yskal));
	dc.LineTo(62, (int) yoffset+ypaint[0]*(-yskal));
	dc.TextOut(64, (int) yoffset+ypaint[0]*(-yskal)-8, d2a(ypaint[0], 2));
	dc.MoveTo(58, (int) yoffset+ypaint[m_n+1]*(-yskal));
	dc.LineTo(62, (int) yoffset+ypaint[m_n+1]*(-yskal));
	dc.TextOut(64, (int) yoffset+ypaint[m_n+1]*(-yskal)-8, d2a(ypaint[m_n+1], 2));
	
	// Titelstring
	CString sFunktion = "";
	m_combobox.GetText(m_combobox.GetCurSel(), sFunktion);
	dc.TextOut(180, 120, sFunktion);
	
	// Zeichne Kurve
	dc.MoveTo((int) xoffset+(xpaint[0]*xskal), (int) yoffset+ypaint[0]*(-yskal));      
	for( i=1; i<=m_n+1; i++ )
	{
		dc.LineTo((int) xoffset+(xpaint[i]*xskal), (int) yoffset+ypaint[i]*(-yskal)); 
	}
	free(xpaint);
	free(ypaint);
}

void CMatlab5Dlg::OnPaint() 
{
	CWnd* rahmen = GetDlgItem(IDC_BOX);
	rahmen->ModifyStyleEx(NULL , WS_EX_LEFTSCROLLBAR); 
	
	CPaintDC dc(this);
	
	//linke Achse
	dc.MoveTo(60, 125);
	dc.LineTo(60, 337);
	
	//Pfeil linke Achse
	dc.MoveTo(60, 115);
	dc.LineTo(55,125);
	dc.LineTo(65,125);
	dc.LineTo(60,115);
	
	//untere Achse
	dc.MoveTo(55, 332);
	dc.LineTo(350, 332);
	
	//Pfeil untere Achse
	dc.MoveTo(360, 332);
	dc.LineTo(350, 327);
	dc.LineTo(350, 336);
	dc.LineTo(360, 332);
}

void CMatlab5Dlg::OnSelchangeListe() 
{	
	reinterpret_cast<CButton *>(GetDlgItem(IDDRAW))->EnableWindow(FALSE);
	m_writeok.ShowWindow(SW_HIDE);
	int comboindex;
    comboindex = m_combobox.GetCurSel();
	
	if (comboindex+1 == 1)
	{
		m_N = _T("20");
		m_TOL = _T("0.00000001");	// 10^-8
		m_toleranz = GetTol(strtod(m_TOL, '\0'));
		m_X0 = _T("1");
		m_X1 = _T("3");
		m_Y0 = _T("17");
		double tmp = 43.0/3.0;	//wegen der Genauigkeit des Bruchs
		m_Y1 = _T((d2a(tmp,15)));
		m_ITMAX = _T("10");
		f(0, 0, 0, 1);
	}
	
	else if (comboindex+1 == 2)
	{
		m_N = _T("10");
		m_TOL = _T("0.00000001");	// 10^-8
		m_toleranz = GetTol(strtod(m_TOL, '\0'));
		m_X0 = _T("1");
		m_X1 = _T("2");
		m_Y0 = _T("2");
		double tmp = 5.0/2.0;	//wegen der Genauigkeit des Bruchs
		m_Y1 = _T((d2a(tmp,15)));
		m_ITMAX = _T("10");
		f(0, 0, 0, 2);
	}	
	else if (comboindex+1 == 3)
	{
		m_N = _T("10");
		m_TOL = _T("0.00000001");	// 10^-8
		m_toleranz = GetTol(strtod(m_TOL, '\0'));
		m_X0 = _T("1");
		m_X1 = _T("2");
		m_Y0 = _T("0.5");
		double tmp = 1.0/3.0;	//wegen der Genauigkeit des Bruchs
		m_Y1 = _T((d2a(tmp,15)));
		m_ITMAX = _T("10");
		f(0, 0, 0, 3);
	}
	else if (comboindex+1 == 4)
	{
		m_N = _T("10");
		m_TOL = _T("0.00000001");	// 10^-8
		m_toleranz = GetTol(strtod(m_TOL, '\0'));
		m_X0 = _T("2");
		m_X1 = _T("3");
		double tmp1 = 0.5 + log(2);
		m_Y0 = _T((d2a(tmp1,15)));
		double tmp2 = 1.0/3.0 + log(3);
		m_Y1 = _T((d2a(tmp2,15)));
		m_ITMAX = _T("10");
		f(0, 0, 0, 4);
	}	
	else if (comboindex+1 == 5)
	{
		m_N = _T("20");
		m_TOL = _T("0.00000001");	// 10^-8
		m_toleranz = GetTol(strtod(m_TOL, '\0'));
		m_X0 = _T("1");
		m_X1 = _T("2");
		m_Y0 = _T("0");
		double tmp2 = log(256);
		m_Y1 = _T((d2a(tmp2,15)));
		m_ITMAX = _T("10");
		f(0, 0, 0, 5);
	}	
	UpdateData(FALSE);
}

CString CMatlab5Dlg::GetTol(double toleranz)
{
	CString buffer = d2a(toleranz, 15);
	
	for (int posi=2; posi<=buffer.GetLength(); posi++)
	{
		if (buffer[posi]!= '0') return ("(10^-" + i2a(posi-1) + ")");
	}	
	return "FEHLER";
}

void CMatlab5Dlg::OnTxtButton() 
{
	UpdateData(TRUE);
	HINSTANCE h_starttest = ShellExecute(0, "open", m_PFAD +".txt", "", "", SW_HIDE);
	if ((int)h_starttest <= 32)	{AfxMessageBox("Ausgabeatei nicht gefunden");}
}

void CMatlab5Dlg::OnExtrapolation() 
{
	UpdateData(TRUE);
	
	m_status = "";
	m_toleranz = GetTol(strtod(m_TOL, '\0'));
	
	UpdateData(FALSE);
	m_writeok.ShowWindow(SW_HIDE);
	reinterpret_cast<CButton *>(GetDlgItem(IDDRAW))->EnableWindow(FALSE);

	int N = atoi(m_N);
	int i = 0, j = 0;
	double* xsave = (double*) malloc((N+1) * sizeof(double));
	double* schritt1 = (double*) malloc((N+1) * sizeof(double));
	double* schritt2 = (double*) malloc((N+1) * sizeof(double));
	double* schritt3 = (double*) malloc((N+1) * sizeof(double));
	
	double* temp1 = (double*) malloc((N+1) * sizeof(double));
	double* temp2 = (double*) malloc((N+1) * sizeof(double));
	double* ausgabe = (double*) malloc((N+1) * sizeof(double));

	LARGE_INTEGER ZeitFrequenz, ZeitStart, ZeitStop;
	QueryPerformanceFrequency(&ZeitFrequenz);
	QueryPerformanceCounter(&ZeitStart);
	
	//1. Schritt
	xpaint = (double*) malloc((N+1) * sizeof(double));
	ypaint = (double*) malloc((N+1) * sizeof(double));

	DiffVerfahren(m_combobox.GetCurSel()+1, N-1);
	for (i=0; i<=N+1; i++)
	{
		schritt1[i] = ypaint[i];
		xsave[i] = xpaint[i];
	}

	//2. Schritt
	xpaint = (double*) malloc((2*N+1) * sizeof(double));
	ypaint = (double*) malloc((2*N+1) * sizeof(double));
	
	DiffVerfahren(m_combobox.GetCurSel()+1, 2*N-1);
	for (j=0; j<=N+1; j++) 
	{
		schritt2[j] = ypaint[2*j];
	}
		
	//3. Schritt
	xpaint = (double*) malloc((4*N+1) * sizeof(double));
	ypaint = (double*) malloc((4*N+1) * sizeof(double));
	
	DiffVerfahren(m_combobox.GetCurSel()+1, 4*N-1);
	for (j=0; j<=N+1; j++) 
	{
		schritt3[j] = ypaint[4*j];
	}

	//Richardson Extrapolations Alorithmus
	for (i=0; i<N+1; i++)
	{
		temp1[i] = (4.0 * schritt2[i] - schritt1[i]) / 3.0;
		temp2[i] = (4.0 * schritt3[i] - schritt2[i]) / 3.0;
		ausgabe[i] = (16.0 * temp2[i] - temp1[i]) / 15.0;
	}

	CFile datei1, datei2, datei3;
	CString sZeile1, sZeile2, sZeile3;
	int nachkommastellen = 12;
	if (datei1.Open(m_PFAD+"_1.txt", CFile::modeCreate|CFile::modeWrite) && datei2.Open(m_PFAD+"_2.txt", CFile::modeCreate|CFile::modeWrite) && datei3.Open(m_PFAD+"_3.txt", CFile::modeCreate|CFile::modeWrite))
		{
		double fehler = 0, exakt = 0;
		//Ext1 mit Fehler zur exakten Lsung
		for (int i=0; i<N+1; i++)
			{
			exakt = fexakt(xsave[i],m_combobox.GetCurSel()+1);
			
			// Bild 1
			sZeile1 = d2a(xsave[i], nachkommastellen) + " " + d2a(ausgabe[i], nachkommastellen) + " " + d2a(fexakt(xsave[i],m_combobox.GetCurSel()+1), nachkommastellen) + "\n";;
						
			//Bild 2
			sZeile2 = d2a(xsave[i], nachkommastellen) + " " + d2a(exakt- temp1[i], nachkommastellen) + " " + d2a(exakt - temp2[i], nachkommastellen) + " " + d2a(exakt - ausgabe[i], nachkommastellen) + "\n";
			
			//Bild 3
			sZeile3 = d2a(xsave[i], nachkommastellen) + " " + d2a(exakt-schritt1[i], nachkommastellen) + " " + d2a(exakt - schritt2[i], nachkommastellen) + " " + d2a(exakt - schritt3[i], nachkommastellen) + "\n";
			
			datei1.Write(sZeile1, sZeile1.GetLength());
			datei2.Write(sZeile2, sZeile2.GetLength());
			datei3.Write(sZeile3, sZeile3.GetLength());
			}
		datei1.Close();
		datei2.Close();
		datei3.Close();
		}
	QueryPerformanceCounter(&ZeitStop);
	double tErgebnis = ((double)ZeitStop.QuadPart - (double)ZeitStart.QuadPart) / (double)ZeitFrequenz.QuadPart;
	
	m_status  = "\r\n-->Richardson Extrapolation zu N=" + i2a(N) + ", " + i2a(2*N) + " und " + i2a(4*N) + " abgeschlossen.";
	m_status += "\r\n-->" + m_PFAD + "_1.txt enthlt spaltenweise: 1. X-Werte  2. berechnete Y-Werte  3. exakte Y-Werte.";
	m_status += "\r\n-->" + m_PFAD + "_2.txt enthlt spaltenweise: 1. X-Werte  2. Fehler(Exakt-EXT2)  3. Fehler(Exakt-EXT2)  4. Fehler(Exakt-EXT3).";
	m_status += "\r\n-->" + m_PFAD + "_3.txt enthlt spaltenweise: 1. X-Werte  2. Fehler(Exakt-Y("+ i2a(N) +"))  3. Fehler(Exakt-Y(" + i2a(2*N) + "))  4. Fehler(Exakt-Y(" + i2a(4*N) + ")).";
	m_status += "\r\n-->Bentigte Zeit: " + d2a(tErgebnis*1000, 12) + " ms";

	UpdateData(FALSE);
	reinterpret_cast<CEdit *>(GetDlgItem(IDC_STATUSFENSTER))->LineScroll(999);
	reinterpret_cast<CButton *>(GetDlgItem(IDDRAW))->EnableWindow(FALSE);
	free(xpaint);
	free(ypaint);
}

void CMatlab5Dlg::OnGnuplot() 
{
	CString ausgabe = "";
	ausgabe += "set origin 0.4, 0.9\n";
	ausgabe += "set title \"Praktikum 6 - Freddi Netterdon - Output\"\n";
	ausgabe += "set function style lines\n";
	ausgabe += "set data style linespoints\n";
	ausgabe += "set grid\n";
	ausgabe += "set size 1.0, 1.0\n";
	ausgabe += "set origin 0.01,0.01\n";
	ausgabe += "set multiplot\n";		
	ausgabe += "set size 0.5,0.5\n";
	ausgabe += "set origin 0.01,0.5\n";
	ausgabe += "plot \"" + m_PFAD + "_1.txt\" u 1:2, \"" + m_PFAD + "_1.txt\" u 1:3\n";	
	ausgabe += "set size 0.5,0.5\n";
	ausgabe += "set origin 0.5,0.5\n";
	ausgabe += "plot \"" + m_PFAD + "_2.txt\" u 1:2, \"" + m_PFAD + "_2.txt\" u 1:3, \"" + m_PFAD + "_2.txt\" u 1:4\n";	
	ausgabe += "set size 0.5,0.5\n";
	ausgabe += "set origin 0.01,0.01\n";
	ausgabe += "plot \"" + m_PFAD + "_3.txt\" u 1:2, \"" + m_PFAD + "_3.txt\" u 1:3, \"" + m_PFAD + "_3.txt\" u 1:4\n";
	ausgabe += "set nomultiplot\n";

	CFile datei;
	if (datei.Open(m_PFAD + "_skript.plt", CFile::modeCreate|CFile::modeWrite))
	{
		datei.Write(ausgabe, ausgabe.GetLength());
		datei.Close();
		m_status += "\r\n-->GNUPlot Skript in "+ m_PFAD + "_skript.plt gespeichert";
		UpdateData(FALSE);
	}
}